import sys
import array

num_1   = 0.6974135904013633
num_2   = 0.3186694819130276
num_199 = 0.0046960553564208
num_200 = 0.1700480222126477
num_511 = 0.4767281875267004
num_625 = 0.3008415152351406

#FIND 0.9481290004682060

def unsigned(n):
	return n & 0xFFFFFFFF

def rshift(val, n):
	return (val % 0x100000000) >> n


# example: http://jazzy.id.au/default/2010/09/22/cracking_random_number_generators_part_3.html #
def unBitshiftLeftXor(value, shift, mask):
	i = 0
	result = 0
	while (i * shift < 32):
		partMask = (rshift(-1, (32 - shift))) << (shift * i)
		part = value & partMask
		value ^= (part << shift) & mask
		result |= part
		i+=1
	return result

def unBitshiftRightXor(value, shift):
	i = 0;
	result = 0;
	while (i * shift < 32):
		partMask = rshift((-1 << (32 - shift)) , (shift * i))
		part = value & partMask
		value ^= rshift(part, shift)
		result |= part
		i+=1
	return result

def back_state(out):
	value = unBitshiftRightXor(out, 18)
	value = unBitshiftLeftXor(value, 15, 4022730752)
	value = unBitshiftLeftXor(value, 7, 2636928640)
	return unBitshiftRightXor(value, 11)
# example #

def find_state(rand):
	ret = []
	tmp = rand*9007199254740992
	a_ = int(tmp/67108864)
	b_ = int(tmp - a_*67108864)
	ret += [str(bin(a_))[2:]]
	ret += [str(bin(b_))[2:]]

	return ret

def gen_state(state,len_):
	ret = []
	i=0
	while (i<int(2**len_)):
		tmp = bin(i)[2:]
		tmp = str("0" * (len_-len(tmp)))+str(tmp)
		ret += [back_state(int(state+tmp,2))]
		i+=1
	return ret

def next_state(st_1,st_2,st_397):
	y = unsigned((unsigned(st_1) & 2147483648) | (unsigned(st_2) & 2147483647))
	next = unsigned(y >> 1)
	next ^= unsigned(st_397)
	if ((y & 1) == 1):
		next ^= unsigned(2567483615)
	return unsigned(next)


def gen_rand(a,b):
	a ^= (a >> 11);
	a ^= (a << 7) & 2636928640;
	a ^= (a << 15) & 4022730752;
	a ^= (a >> 18);

	b ^= (b >> 11);
	b ^= (b << 7) & 2636928640;
	b ^= (b << 15) & 4022730752;
	b ^= (b >> 18);

	a = a >> 5
	b = b >> 6

	return ((a*67108864.0+b)*(1.0/9007199254740992.0))

state1_12  = find_state(num_1)
state1_34  = find_state(num_2)
state1_397 = find_state(num_199)
state1_398 = find_state(num_200)
state2_397 = find_state(num_511)
state3_1   = find_state(num_625)

_state_1_1   = gen_state(state1_12[0],5)
_state_1_2   = gen_state(state1_12[1],6)
_state_1_3   = gen_state(state1_34[0],5)
_state_1_397 = gen_state(state1_397[1],6)
_state_1_398 = gen_state(state1_398[0],5)
_state_2_397 = gen_state(state2_397[1],6)
_state_3_1   = gen_state(state3_1[0],5)

_state_2_1 = []
_state_2_2 = []

i=0
while (i<len(_state_1_1)):
	j=0
	while (j<len(_state_1_2)):
		k=0
		while (k<len(_state_1_397)):
			next = next_state(_state_1_1[i],_state_1_2[j],_state_1_397[k])
			if (next not in _state_2_1):
				_state_2_1 += [next]
			k+=1
		j+=1
	i+=1

i=0
while (i<len(_state_1_2)):
	j=0
	while (j<len(_state_1_3)):
		k=0
		while (k<len(_state_1_398)):
			next = next_state(_state_1_2[i],_state_1_3[j],_state_1_398[k])
			if (next not in _state_2_2):
				_state_2_2 += [next]
			k+=1
		j+=1
	i+=1

print (len(_state_2_1))
print (len(_state_2_2))
candidate_1 = []
candidate_2 = []
i=0

while (i<len(_state_2_1)):
	print (i)
	j=0
	while (j<len(_state_2_2)):
		k=0
		while (k<len(_state_2_397)):
			next = next_state(_state_2_1[i],_state_2_2[j],_state_2_397[k])
			if (next in _state_3_1):
				if _state_2_1[i] not in candidate_1:
					candidate_1 += [_state_2_1[i]]
				if _state_2_2[j] not in candidate_2:
					candidate_2 += [_state_2_2[j]]
			k+=1
		j+=1
	i+=1

i=0
rands = []
file = open('brute_result.txt', 'a+')
while (i<len(candidate_1)):
	j=0
	while (j<len(candidate_2)):
		rand = gen_rand(candidate_1[i],candidate_2[j])
		if rand<1 and rand not in rands:
			file.write(str(rand)+"\r\n")
			rands += [rand]
		j+=1
	i+=1

file.close()